;***************************************************************************
;* 									   *
;* AS 1.40 - DEMOCODE.ASM                                                  *
;*									   *
;* demonstriert die veschiedenen von AS untersttzten Prozessortypen	   *
;* anhand einer Verzgerungsschleife, die fr jede Prozessorfamilie        *
;* kodiert wird.							   *
;*									   *
;* bersetzen mit       as democode					   *
;*									   *
;* Schauen Sie sich das erzeugte Codefile mit PLIST an !                   *
;*									   *
;* letzte nderungen: 16. 1.1993					   *
;*                    19. 9.1993 PIC, 8086,ST62xx,TMS3201x,Z8              *
;*                     1. 4.1994 DSP56, 8096, TLCS-90, TLCS-870, TLCS-47,  *
;*                               PIC16C84, 6804, 7810                      *
;*                    11. 9.1994 TLCS-9000, MELPS7700, MPC601, H8, 80C166, *
;*                               TMS370xx                                  *
;*                                                                         *
;***************************************************************************

;---------------------------------------------------------------------------
; Wichtig: der Schleifenbefehl beim 68000 luft bis -1 !

		cpu	68000

Delay_68000:	move.w	#254,d0
Schl_68000:     dbra	d0,Schl_68000

;---------------------------------------------------------------------------
; 68er / 65er - Familie : fast die gleiche Source, jedoch anderer Code:
; die 16-Bitter bringen auch keine neuen Erkenntnise

		cpu	6502

Delay_6502:	ldx	#255
Schl_6502:	dex
		bne	Schl_6502

		cpu	6800

Delay_6800:	ldaa	#255
Schl_6800:	deca
		bne	Schl_6800

		cpu	6805

Delay_6805:	lda	#$ff
Schl_6805:	deca
		bne	Schl_6805

                cpu     6809

Delay_6809:     lda     #255
Schl_6809:      deca
                bne     Schl_6809

                cpu     melps7700

                assume  m:0
Delay_7700:     lda     #256
Schl_7700:      dec     a
                bne     Schl_7700

;---------------------------------------------------------------------------
; H8: fast wie 68K

                cpu     hd6413309

Delay_H8:       mov.b   #255,r0l
Schl_H8:        add.b   #255,r0l
                bne     Schl_H8

;---------------------------------------------------------------------------
; SH7000: LTORG nicht vergessen, denn nur -128..127 direkt ladbar

                cpu     sh7000

Delay_7000:     mov     #256,r0
                mov     #1,r1   ; Dekrement
Schl_7000:      sub     r1,r0
                cmp/eq  #0,r0
                bf      Schl_7000
                ltorg

;---------------------------------------------------------------------------
; DSP56: Paper-Design!!

                cpu     56000

Delay_56000:    do      #255,Schl_56000
Schl_56000:     nop

;---------------------------------------------------------------------------
; Power-PC: MIPs im Leerlauf...

                cpu     mpc601

Delay_601:      addi    r3,r0,256       ; Nullregister immer Null
                addi    r4,r0,-1
Schl_601:       subf.   r3,r3,r4
                bc      4,10,Schl_601

;---------------------------------------------------------------------------
; MEPLS-4500: Bei einem 4-Bitter etwas mehr Arbeit

                cpu     melps4500

Delay_4500:     lxy     15,15
Schl_4500_1:    tax
Schl_4500_2:    a       15              ; ergibt 15 Carrys=nicht-skips
                b       Schl_4500_2
                dey
                b       Schl_4500_1     ; skipped, falls Y von 0-->15

;---------------------------------------------------------------------------
; Intel-Mikrokontroller : identische (!) Source, aber gnzlich andere Codes:

		cpu	8039

Delay_8039:	mov	r0,#255
Schl_8039:	djnz	r0,Schl_8039

		cpu	8051

Delay_8051:	mov	r0,#255
Schl_8051:	djnz	r0,Schl_8051

                cpu     8096

Delay_8096:     ldb     20h,#255        ; Adresse 32= Schleifenzhler
Schl_8096:      djnz    20h,Schl_8096

;---------------------------------------------------------------------------
; der 8085 hat keinen Schleifenbefehl, der Z80 kann es besser:
; der TMP96C141 in 16 Bit (sein kleiner Bruder knnte es auch)
; die kleineren Versionen wieder nicht
; beim 47er mssen wir das zerlegen

		cpu	8085

Delay_8085:	mvi	a,255		; Z80 : ld    a,255
Schl_8085:	dcr	a		;	dec   a
		jnz	Schl_8085	;	jp    nz,Schl_8085

		cpu	z80

Delay_Z80:      ld      b,255
Schl_Z80:	djnz	Schl_Z80

                cpu     96c141

Delay_141:      ld      bc,255
Schl_141:       djnz    bc,Schl_141

                cpu     90c141

Delay_90141:    ld      b,255
Schl_90141:     djnz    Schl_90141

                cpu     87c00

Delay_87C00:    ld      a,255
Schl_87C00:     dec     a
                jr      nz,Schl_87C00

                cpu     47c00

Delay_47C00:    ld      a,#15           ; Bit 0..3 in A
                ld      l,#15           ; Bit 4..7 in L
Schl_47C00:     dec     a
                b       Skip1_47C00     ; falls C=1...
                b       Schl_47C00
Skip1_47C00:    dec     l               ; ...High-Nibble runter
                b       Skip2_47C00
                b       Schl_47C00
Skip2_47C00:

                cpu     97c241

Delay_97C241:   ld.d    rd2,256
Schl_97C241:    djnz.d  rd2,Schl_97C241


;------------------------------------------------------------------------------
; die PICs: wie Drillinge, nur Statusregister woanders

                cpu     16c54

Delay_16C54:    movlw   1               ; Dekrement
                movwf   10              ; speichern
                movlw   255             ; Durchlaufszahl
Schl_16C54:     subwf   10,w
                btfss   3,2             ; Z=1 ?
                goto    Schl_16C54

                cpu     16C84

Delay_16C84:    movlw   1
                movwf   10
                movlw   255
Schl_16C84:     subwf   10,w
                btfss   3,2
                goto    Schl_16C84

                cpu     17C42

Delay_17C42:    movlw   1
                movwf   10
                movlw   255
Schl_17C42:     subwf   10,w
                btfss   4,2
                goto    Schl_17C42

;------------------------------------------------------------------------------
; 8086: natrlich mit LOOP....

                cpu     8086

Delay_8086:     mov     cx,255
Schl_8086:      loop    Schl_8086

;------------------------------------------------------------------------------
; ST62xx: sieht ja aus wie Z80, hat aber keinen DJNZ
; 6804: wir drehen die Bits...

                cpu     st6210

Delay_ST62:     ldi     a,255
Schl_ST62:      subi    a,1
                jrnz    Schl_ST62

                cpu     6804

Delay_6804:     lda     #255
Schl_6804:      sub     #1
                bne     Schl_6804

;------------------------------------------------------------------------------
; Texas: Hilfsregister als Zhler (geht nur bis 512 Durchlufe!)
; beim 20er mu man zustzlich die Adressierungsart angeben

                cpu     32010

Delay_TMS1:     larp    ar0
                lark    ar0,254         ; !!!
Schl_TMS1:      banz    Schl_TMS1

                cpu     320C25

Delay_TMS2x:    larp    ar0
                lark    ar0,254         ; !!!
Schl_TMS2x:     banz    Schl_TMS2x,*-

                cpu     320C30

Delay_TMS3x:    ldi     255,ar3
Schl_TMS3x:     db      ar3,Schl_TMS3x

;------------------------------------------------------------------------------

                cpu     370c010

Delay_370:      mov     #255,r0
Schl_370:       djnz    r0,Schl_370

;------------------------------------------------------------------------------
; Z8: wie Z80 (eben Zilog), nur mit numerierten Registern

                cpu     z8601

Delay_Z8:       ld      r0,#255
Schl_Z8:        djnz    r0,Schl_Z8

;------------------------------------------------------------------------------

                cpu     80C166

Delay_166:      mov     r0,#256
Schl_166:       sub     r0,#1
                jmpr    ne,Schl_166

;------------------------------------------------------------------------------
; 7810: 8085-Mnemonics lassen gren

                cpu     7810

Delay_7810:     mvi     a,255
Schl_7810:      dcr     a
                sk      z
                jr      Schl_7810

